function [sys,x0]=alg_reak(t,x,u,flag)

% x(1)	[mol/m^3] 
% x(2)	[K]
% M	[kg/mol]
% ro 	[kg/cm^3]
% V	[cm^3]
% Cp	[J/kg.K]
% k	[cm^3/mol.s]
% H 	[J/mol]
% E	[J/mol]
% A*alfa[J/s.K]
% ks	[1]
% k1ch	[Ws/cm^3.K]
% k2ch	[Ws^2/cm^6.K]

% REAKTANTY
Ma=0.034;
Mb=0.29419;
roa=0.001;
rob=0.001;
Tin=273.15+25;

% PARAMETRE REAKCIE
H=-98300;
R=8.314;
E=3.0917e4;
k=9.0883e+006;

% REAKN ZMES
ro=0.001;
Vr=940;
Cp=4180;

% PARAMETRE HADA
% Ako sucin A*alfa=116.09
alfa=116.09;
A=1;

% CHLADIVO
Tchi=273.15+25;
k1ch=4.4256;
k2ch=-0.1407;

% OKOLIE
Tout=273.15+25;
ks=0.007;
Vp=Vr/0.94;
beta=ks*alfa*A;

if flag==0
	sys=[2;0;2;5;0;0];
	x0=[1.5204e-004;306.4042];
elseif flag==1
	% Celkov prietok reaktorom
	u(2)=u(2)/60;
	u(4)=u(4)/60;
	u(5)=u(5)/60;
	q=u(2)+u(4);
	% Prepoet hmot. kon. na mol. konc.
	con_p0=(u(1)*roa/Ma);
	con_d0=(u(3)*rob/Mb);
	con_d=u(4)*con_d0/(q);
	% Vpoet reak. rchl. vztiahnutej na cm^3
	r=2*k*x(1)*con_d*exp(-E/(x(2)*R));
	% Stavov opis
	dx(1)=((u(2)*con_p0-q*x(1))/Vr)-r;
	dx(2)=((-H*r*Vr)/(Vp*ro*Cp))+((q*(Tin-x(2)))/Vp)-(k1ch*u(5)+k2ch*u(5)^2)*(x(2)-Tchi)/(Vp*ro*Cp)-(beta*(x(2)-Tout))/(Vp*ro*Cp);
	%%%%%%%%%%%%%%
	sys=[dx(1) dx(2)];
elseif flag==3
	sys=[x(1) x(2)];
else
	sys=[];
end